var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/editor/extension/completionDisplay.tsx
var completionDisplay_exports = {};
__export(completionDisplay_exports, {
  CompletionDisplay: () => CompletionDisplay,
  completionSource: () => completionSource
});
module.exports = __toCommonJS(completionDisplay_exports);
var import_react = __toESM(require("react"));
var import_react_dom = __toESM(require("react-dom"));
var import_autocomplete = require("@codemirror/autocomplete");
var import_lang_javascript = require("@codemirror/lang-javascript");
var import_utils = require("../utils");
var import_type = require("../type");
var import_Info = __toESM(require("../components/Info"));
var import_view = require("@codemirror/view");
var SpecialChar = [
  "!",
  "@",
  "#",
  "$",
  "^",
  "&",
  "*",
  ",",
  "-",
  "~",
  "\\",
  "'"
];
var renderInfo = (completion) => {
  const { docs: content, type, label: name, detail } = completion;
  const hintDiv = document.createElement("div");
  import_react_dom.default.render(/* @__PURE__ */ import_react.default.createElement(import_Info.default, { info: { content: detail ?? content, type, name } }), hintDiv);
  return hintDiv;
};
var defineInfoRenderer = (completions) => {
  var _a;
  return (_a = completions || []) == null ? void 0 : _a.map((completion) => {
    const showInfo = completion.detail || completion.docs;
    return {
      type: import_type.CompletionType.variable,
      ...completion,
      info: (completion2) => {
        return showInfo ? renderInfo(completion2) : null;
      }
    };
  });
};
var triggerWithSpecialChar = (docInfo, word) => {
  const endChar = Array.from(word.text).pop();
  if (docInfo.name === "" && SpecialChar.includes(endChar)) {
    return true;
  }
  return false;
};
var completionSource = (completions) => async (context) => {
  const docInfo = (0, import_lang_javascript.completionPath)(context);
  console.log(docInfo);
  const word = context.matchBefore(/.*/);
  if (!word || !docInfo || word && word.from == word.to && !context.explicit)
    return null;
  const childCompletions = (0, import_utils.findCompletions)(
    docInfo.name,
    [...docInfo.path],
    completions
  );
  const definedCompletions = defineInfoRenderer(childCompletions);
  let from = context.pos - docInfo.name.length;
  if (triggerWithSpecialChar(docInfo, word)) {
    from--;
  }
  return {
    from,
    options: definedCompletions
  };
};
var debouncedStartCompletion = (0, import_utils.debounce)(function(view) {
  (0, import_autocomplete.startCompletion)(view);
}, 200);
var CompletionDisplay = () => {
  return import_view.EditorView.inputHandler.of((view, from, to, text) => {
    (0, import_autocomplete.closeCompletion)(view);
    debouncedStartCompletion(view);
    return false;
  });
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  CompletionDisplay,
  completionSource
});
