var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/editor/index.tsx
var editor_exports = {};
__export(editor_exports, {
  default: () => editor_default
});
module.exports = __toCommonJS(editor_exports);
var import_react = __toESM(require("react"));
var import_state = require("@codemirror/state");
var import_view = require("@codemirror/view");
var import_lang_javascript = require("@codemirror/lang-javascript");
var import_codemirror_theme_xcode = require("@uiw/codemirror-theme-xcode");
var import_autocomplete = require("@codemirror/autocomplete");
var import_codemirror_extensions_basic_setup = require("@uiw/codemirror-extensions-basic-setup");
var import_extension = require("./extension");
var import_index_module = __toESM(require("./index.module.less"));
var DefaultBasicOptions = {
  lineNumbers: false,
  foldGutter: false,
  highlightActiveLine: false,
  bracketMatching: true,
  closeBrackets: true,
  closeBracketsKeymap: true,
  tabSize: 2,
  autocompletion: true,
  searchKeymap: false,
  syntaxHighlighting: true
};
var CodeEditor = ({
  value,
  theme,
  completions = [],
  placeholder: placeholderStr = "请输入表达式",
  events,
  options = DefaultBasicOptions,
  className,
  onChange
}, ref) => {
  const containerRef = (0, import_react.useRef)();
  const [view, setView] = (0, import_react.useState)();
  (0, import_react.useImperativeHandle)(
    ref,
    () => ({
      ...view,
      getDoc() {
        return view.state.doc.toString();
      },
      insertDoc
    }),
    [view]
  );
  const customTheme = (0, import_react.useMemo)(() => (0, import_extension.defineTheme)(theme), [theme]);
  const placeHolder = (0, import_react.useMemo)(
    () => (0, import_view.placeholder)(placeholderStr),
    [placeholderStr]
  );
  const autocompletionExtension = (0, import_react.useMemo)(
    () => (0, import_autocomplete.autocompletion)({
      activateOnTyping: false,
      override: [(0, import_extension.completionSource)(completions)]
    }),
    [completions]
  );
  const readOnly = (0, import_react.useMemo)(
    () => import_state.EditorState.readOnly.of(!!(options == null ? void 0 : options.readonly)),
    [options == null ? void 0 : options.readonly]
  );
  const insertDoc = (0, import_react.useCallback)(
    (text) => {
      const { anchor, head } = view.state.selection.ranges[0];
      view.dispatch({
        changes: { from: head, insert: text || "" },
        selection: import_state.EditorSelection.range(anchor, head)
      });
    },
    [view]
  );
  (0, import_react.useEffect)(() => {
    const state = import_state.EditorState.create({
      doc: value,
      extensions: [
        (0, import_codemirror_extensions_basic_setup.basicSetup)({ ...DefaultBasicOptions, ...options }),
        readOnly,
        customTheme,
        placeHolder,
        (0, import_extension.EventExt)(events),
        import_codemirror_theme_xcode.xcodeLight,
        (0, import_lang_javascript.javascript)(),
        autocompletionExtension,
        (0, import_extension.CompletionDisplay)(),
        (0, import_extension.UpdateListener)(onChange),
        import_view.EditorView.lineWrapping
      ]
    });
    const view2 = new import_view.EditorView({
      parent: containerRef.current,
      state
    });
    setView(view2);
    return () => {
      view2.destroy();
    };
  }, [readOnly]);
  (0, import_react.useEffect)(() => {
    if (value === void 0) {
      return;
    }
    const currentValue = view ? view.state.doc.toString() : "";
    if (view && value !== currentValue) {
      insertDoc(value);
    }
  }, [value, view]);
  (0, import_react.useEffect)(() => {
    if (view) {
      view.state.update({
        effects: import_state.StateEffect.reconfigure.of([autocompletionExtension])
      });
    }
  }, [autocompletionExtension]);
  return /* @__PURE__ */ import_react.default.createElement(
    "div",
    {
      className: `${import_index_module.default.container} ${className ?? ""}`,
      ref: containerRef
    }
  );
};
var editor_default = (0, import_react.forwardRef)(CodeEditor);
