var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/editor/utils.ts
var utils_exports = {};
__export(utils_exports, {
  debounce: () => debounce,
  findCompletions: () => findCompletions
});
module.exports = __toCommonJS(utils_exports);
var findCompletions = (keyword, path, completions) => {
  if (!path.length) {
    if (!keyword.trim()) {
      return completions;
    } else {
      return completions.filter(({ label }) => label == null ? void 0 : label.startsWith(keyword));
    }
  } else {
    const childCompletions = findTargetLevel(path, completions);
    if (!keyword.trim()) {
      return childCompletions;
    } else {
      return childCompletions.filter(({ label }) => label == null ? void 0 : label.startsWith(keyword));
    }
  }
};
var findTargetLevel = (path, completions) => {
  const keyword = path.shift();
  const currentLevelCompletion = completions.find(
    ({ label }) => label === keyword
  );
  if (!!path.length && currentLevelCompletion) {
    return findTargetLevel(path, currentLevelCompletion.properties);
  }
  return (currentLevelCompletion == null ? void 0 : currentLevelCompletion.properties) || [];
};
function debounce(fn, delay) {
  let timer = null;
  return function() {
    let context = this;
    let arg = arguments;
    timer && clearTimeout(timer);
    timer = setTimeout(function() {
      fn.apply(context, arg);
    }, delay);
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  debounce,
  findCompletions
});
