var __defProp = Object.defineProperty;
var __defProps = Object.defineProperties;
var __getOwnPropDescs = Object.getOwnPropertyDescriptors;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __spreadProps = (a, b) => __defProps(a, __getOwnPropDescs(b));
var __async = (__this, __arguments, generator) => {
  return new Promise((resolve, reject) => {
    var fulfilled = (value) => {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    };
    var rejected = (value) => {
      try {
        step(generator.throw(value));
      } catch (e) {
        reject(e);
      }
    };
    var step = (x) => x.done ? resolve(x.value) : Promise.resolve(x.value).then(fulfilled, rejected);
    step((generator = generator.apply(__this, __arguments)).next());
  });
};

// src/editor/extension/completionDisplay.tsx
import React from "react";
import ReactDOM from "react-dom";
import {
  startCompletion,
  closeCompletion
} from "@codemirror/autocomplete";
import { completionPath } from "@codemirror/lang-javascript";
import { findCompletions, debounce } from "../utils";
import { CompletionType } from "../type";
import Info from "../components/Info";
import { EditorView } from "@codemirror/view";
var SpecialChar = [
  "!",
  "@",
  "#",
  "$",
  "^",
  "&",
  "*",
  ",",
  "-",
  "~",
  "\\",
  "'"
];
var renderInfo = (completion) => {
  const { docs: content, type, label: name, detail } = completion;
  const hintDiv = document.createElement("div");
  ReactDOM.render(/* @__PURE__ */ React.createElement(Info, { info: { content: detail != null ? detail : content, type, name } }), hintDiv);
  return hintDiv;
};
var defineInfoRenderer = (completions) => {
  var _a;
  return (_a = completions || []) == null ? void 0 : _a.map((completion) => {
    const showInfo = completion.detail || completion.docs;
    return __spreadProps(__spreadValues({
      type: CompletionType.variable
    }, completion), {
      info: (completion2) => {
        return showInfo ? renderInfo(completion2) : null;
      }
    });
  });
};
var triggerWithSpecialChar = (docInfo, word) => {
  const endChar = Array.from(word.text).pop();
  if (docInfo.name === "" && SpecialChar.includes(endChar)) {
    return true;
  }
  return false;
};
var completionSource = (completions) => (context) => __async(void 0, null, function* () {
  const docInfo = completionPath(context);
  console.log(docInfo);
  const word = context.matchBefore(/.*/);
  if (!word || !docInfo || word && word.from == word.to && !context.explicit)
    return null;
  const childCompletions = findCompletions(
    docInfo.name,
    [...docInfo.path],
    completions
  );
  const definedCompletions = defineInfoRenderer(childCompletions);
  let from = context.pos - docInfo.name.length;
  if (triggerWithSpecialChar(docInfo, word)) {
    from--;
  }
  return {
    from,
    options: definedCompletions
  };
});
var debouncedStartCompletion = debounce(function(view) {
  startCompletion(view);
}, 200);
var CompletionDisplay = () => {
  return EditorView.inputHandler.of((view, from, to, text) => {
    closeCompletion(view);
    debouncedStartCompletion(view);
    return false;
  });
};
export {
  CompletionDisplay,
  completionSource
};
