// src/editor/extension/theme.ts
import { EditorView } from "@codemirror/view";
var ThemeKey = /* @__PURE__ */ ((ThemeKey2) => {
  ThemeKey2["root"] = "&";
  ThemeKey2["focused"] = "&.cm-editor.cm-focused";
  ThemeKey2["matchingBracket"] = "&.ͼ1 .cm-matchingBracket, &.ͼ1.cm-focused .cm-matchingBracket";
  return ThemeKey2;
})(ThemeKey || {});
var defineTheme = (theme = {}) => {
  const defaultTheme = {
    "&": {
      backgroundColor: "inherit !important",
      height: "100%",
      width: "100%"
    },
    "&.cm-editor.cm-focused": {
      outline: "1px solid #4096ff"
    },
    "&.ͼ1 .cm-matchingBracket, &.ͼ1.cm-focused .cm-matchingBracket": {
      color: "#40A072",
      backgroundColor: "#fff"
    }
  };
  for (const [key, value] of Object.entries(theme)) {
    defaultTheme[ThemeKey[key]] = value;
  }
  return EditorView.baseTheme(defaultTheme);
};
export {
  defineTheme
};
