// src/editor/extension/updateListener.ts
import { EditorView } from "@codemirror/view";
import { Annotation } from "@codemirror/state";
var External = Annotation.define();
var UpdateListener = (onChange) => {
  return EditorView.updateListener.of((view) => {
    if (view.docChanged && typeof onChange === "function" && // Fix echoing of the remote changes:
    // If transaction is market as remote we don't have to call `onChange` handler again
    !view.transactions.some((tr) => tr.annotation(External))) {
      const doc = view.state.doc;
      const value = doc.toString();
      onChange(value, view);
    }
  });
};
export {
  UpdateListener
};
