// src/editor/utils.ts
var findCompletions = (keyword, path, completions) => {
  if (!path.length) {
    if (!keyword.trim()) {
      return completions;
    } else {
      return completions.filter(({ label }) => label == null ? void 0 : label.startsWith(keyword));
    }
  } else {
    const childCompletions = findTargetLevel(path, completions);
    if (!keyword.trim()) {
      return childCompletions;
    } else {
      return childCompletions.filter(({ label }) => label == null ? void 0 : label.startsWith(keyword));
    }
  }
};
var findTargetLevel = (path, completions) => {
  const keyword = path.shift();
  const currentLevelCompletion = completions.find(
    ({ label }) => label === keyword
  );
  if (!!path.length && currentLevelCompletion) {
    return findTargetLevel(path, currentLevelCompletion.properties);
  }
  return (currentLevelCompletion == null ? void 0 : currentLevelCompletion.properties) || [];
};
function debounce(fn, delay) {
  let timer = null;
  return function() {
    let context = this;
    let arg = arguments;
    timer && clearTimeout(timer);
    timer = setTimeout(function() {
      fn.apply(context, arg);
    }, delay);
  };
}
export {
  debounce,
  findCompletions
};
